// Next.js API route support: https://nextjs.org/docs/api-routes/introduction
import type {NextApiRequest, NextApiResponse} from "next";
import {app} from "@/firebase";
import {getFirestore, collection, getDocs, setDoc, doc} from "firebase/firestore";
import {withIronSessionApiRoute} from "iron-session/next";
import {sessionOptions} from "@/lib/session";
import {Group} from "@/interfaces/user";
import {v4} from "uuid";

const db = getFirestore(app);

export default withIronSessionApiRoute(handler, sessionOptions);

async function handler(req: NextApiRequest, res: NextApiResponse) {
	if (!req.session.user) {
		res.status(401).json({ok: false});
		return;
	}

	if (req.method === "GET") await get(req, res);
	if (req.method === "POST") await post(req, res);
}

async function get(req: NextApiRequest, res: NextApiResponse) {
	const {admin} = req.query as {admin: string};
	const snapshot = await getDocs(collection(db, "groups"));

	const groups: Group[] = snapshot.docs.map((doc) => ({
		id: doc.id,
		...doc.data(),
	})) as Group[];

	if (admin) {
		res.status(200).json(groups.filter((x) => x.admin === admin));
		return;
	}

	res.status(200).json(
		snapshot.docs.map((doc) => ({
			id: doc.id,
			...doc.data(),
		})),
	);
}

async function post(req: NextApiRequest, res: NextApiResponse) {
	const body = req.body as Group;

	await setDoc(doc(db, "groups", v4()), {name: body.name, admin: body.admin, participants: body.participants});
	res.status(200).json({ok: true});
}
